#include <Wire.h>
#include "Adafruit_FONA.h"

//#include "SPI.h"  // Delete this!
#define FONA_RX 3
#define FONA_TX 4
#define FONA_RST 5

// Connect Nano A5 to Maga SCL
// Connect Nano A4 to Mega SDA

// this is a large buffer for replies
char replybuffer[255];
String initiator;
String dataString = "";
char url[60] = "http://www.########################################.php";
String urlString = "http://www.########################################.php";
String nothing;
String numberA;
int stringLength =0;
String testad;
int w=10;
int n=0;
int i=0;
String compileA;
char rabbits[100];
String a="";
int k;
int z=0;
int result = 1234;
String recieve;
String cString = "1";
int phpPage =0;
int previousPhpPage =0;
unsigned long millisCalc1;
unsigned long previousMillis1; 
int ledState;
int ledPin=13;

#include <SoftwareSerial.h>
SoftwareSerial fonaSS = SoftwareSerial(FONA_TX, FONA_RX);
SoftwareSerial *fonaSerial = &fonaSS;

//Connect Rx on Fona to Tx1 on mega or due:
//HardwareSerial *fonaSerial = &Serial1;

Adafruit_FONA fona = Adafruit_FONA(FONA_RST);
uint8_t readline(char *buff, uint8_t maxbuff, uint16_t timeout = 0);
uint8_t type;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup() 
{
  Wire.begin(43);                // join i2c bus with address #43
  Wire.onReceive(receiveEvent); // register event
  Wire.onRequest(requestEvent); // register event
  Serial.begin(115200);
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW);
  pinMode(12, OUTPUT);
  digitalWrite(12, LOW);
  pinMode(11, OUTPUT);
  digitalWrite(11, LOW);
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
  while (!Serial);                           // Use this for initiating program by opening of serial monitor. Delete in normal operation.

  Serial.println(F("FONA basic test"));
  Serial.println(F("Initialising....(May take 3 seconds)"));


  fonaSerial->begin(4800);
  if (! fona.begin(*fonaSerial)) {
    Serial.println(F("Couldn't find FONA"));
//   while (1);
  }
  type = fona.type();
  Serial.println(F("FONA is OK"));
  Serial.print(F("Found "));
  switch (type) {
    case FONA800H:
      Serial.println(F("FONA 800H")); break;
  }
  //networkStatus();   // Check the network is available. Home is good.
  
        Serial.println("");
        Serial.println("Checking that GPRS is turned off to start with .........");
  fona.setGPRSNetworkSettings(F("pp.vodafone.co.uk"), F("wap"), F("wap"));   // Change these settings! (Network APN, username ,password)
//delay (1000);
        // Turn off GPRS:
        if (!fona.enableGPRS(false))
        Serial.println(F("No - Failed to turn off"));
        Serial.println("If the line above says OK, then GPRS has just been turned off");
//delay (1000);
    //networkStatus();   // Check the network is available. Home is good.
    turnOnGPRS();
    turnOnGPRS();
    delay (500);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   Serial.println("Let's now do some work with the database  ...........");
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop() 
{
  phpPage = (cString).toInt();
  if(phpPage==previousPhpPage)
  {
    unsigned long currentMillis = millis();
    millisCalc1 = currentMillis - previousMillis1; 
      if (millisCalc1 >= 1000)                            // timer .....  5,000
      {
        if (ledState == LOW) 
        {
          ledState = HIGH;
        } 
        else
        {
          ledState = LOW;
        }
        digitalWrite(ledPin, ledState);
        previousMillis1 = currentMillis;
      }
    Serial.print("previousPhpPage:  ");Serial.println(previousPhpPage);
    Serial.print("phpPage:          ");Serial.println(phpPage);
    //delay(1000);
  }
  else
  {
  recieveData();
  delay(1000);
  recieveData();
  characterCompile();
  previousPhpPage = phpPage;
  }
  //delay (360000);            // 3600000 One hour
}
//////////////////////////////////////////////////////////////////////////////////////////////////
// End of main loop.
void receiveEvent(int howMany) // Recieves data about which /select.php file to read next
{
  while (Wire.available())
  {
    char c = Wire.read(); // receive byte as a character, eg 7
    cString = c;
    //Serial.print("Here is select php url from TC275: ");Serial.println(cString);
    urlString =  "http://www.########################################" + cString + ".php";
    //Serial.print("url string recieved from TC275: ");Serial.println(urlString);
  }
    // Builds the url character:
    int n =  60; 
    //for (int aa=0;aa<=n;aa++)                                              
   // {
   //   url[aa]="";
  //  }
    n = urlString.length()-1;
    for (int aa=0;aa<=n;aa++)                                              
    {
      url[aa] = urlString[aa];     // Character = String
    }
    Serial.print("url character recieved from TC275: ");Serial.println(url);
}
void requestEvent() 
{  
  //Wire.write(rabbits[1]);
  Wire.write(rabbits[2]);
  Wire.write(rabbits[3]); // as expected by master
  Wire.write(rabbits[4]);
  Wire.write(rabbits[5]);
  Wire.write(rabbits[6]);
  Wire.write(rabbits[7]);
  Wire.write(rabbits[8]);
  Wire.write(rabbits[9]);
  Wire.write(rabbits[10]);
  Wire.write(rabbits[11]);
  Wire.write(rabbits[12]);  
  Wire.write(rabbits[13]);
  Wire.write(rabbits[14]);
  Wire.write(rabbits[15]);
  Wire.write(rabbits[16]);
  Wire.write(rabbits[17]);
  Wire.write(rabbits[18]);
  Wire.write(rabbits[19]);
  Wire.write(rabbits[20]);
  Wire.write(rabbits[21]); 
  Wire.write(rabbits[22]);
  Wire.write(rabbits[23]); 
  Wire.write(rabbits[24]);
  Wire.write(rabbits[25]); 
  Wire.write(rabbits[26]);
  Wire.write(rabbits[27]);
  
  //    for (int aa=2;aa<=n;aa++)   // For some reason this does not work.                                           
  //    {
  //        Wire.write(rabbits);
  //    }
  digitalWrite(13, HIGH);
  delay(100);
  digitalWrite(13, LOW);
}
void characterCompile()
{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This is where the data is compiled into a character ....
  dataString =  initiator  + recieve;  // Limited to 32 characters for some reason !!!
  int n =  31;                                                      // dataString.length();
  Serial.print("Data string to recieve:     ");Serial.println(dataString);   
  Serial.print("Size of string:  ");Serial.println(n);
  // Builds the rabbits character, which is lat and long coordinates from database.
      for (int aa=0;aa<=n;aa++)                                              
      {
          rabbits[aa] = dataString[aa];
      }
  Serial.print("Character data recieved:  ");Serial.println(rabbits);
  Serial.println("");
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
}
void recieveData()
{
        recieve="";
        digitalWrite(12, HIGH);
        delay(1000);
        // read website URL
        uint16_t statuscode;
        int16_t length;
        if (!fona.HTTP_GET_start(url, &statuscode, (uint16_t *)&length)) {
          Serial.println("Failed!");
          //break;
        }
        while (length > 0) {
          while (fona.available()) 
          {
            char ccc = fona.read();
            recieve=recieve+ccc;                      // string = string + character
            // Serial.write is too slow, we'll write directly to Serial register!
#if defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168__)
            loop_until_bit_is_set(UCSR0A, UDRE0); /* Wait until data register empty. */
            UDR0 = ccc;
 
#else
            Serial.write(ccc);
            
#endif
            length--;
            if (! length);
          }
        }
        Serial.println(F("\n****"));
        fona.HTTP_GET_end();
        digitalWrite(12, LOW);
}
//////////////////////////////////////////////////////////////////////////////////
void turnOnGPRS()
{    
        //delay (10000);
        Serial.println("Now attempting to turn on GPRS .........");
     //   if (!fona.enableGPRS(true))
     //   Serial.println(F("No - Failed to turn on"));
     //   Serial.println("GPRS is on if the line above shows 'OK'");
     //   Serial.println("Wait for 10 seconds to make sure GPRS is on ...........");        
     //   delay (10000);
        if (fona.enableGPRS(true))
        digitalWrite(11, HIGH);                     // Orange LED
     //   ledFastFlashB();                          // Indicates a connect to GPRS.

    //    Serial.println(("No - Failed to turn on"));
}

